
//	Property Sheet for Microsoft Xbox 360 Wireless Controller

#include	"actuator_page.h"
#include	"resource.h"

//----------------------------------------------------------------------------------------------
//	CActuatorPage
//----------------------------------------------------------------------------------------------
CActuatorPage::CActuatorPage( CSetting * Setting )
{
	//	ݒ
	this->Setting		= Setting;

	//	݂̃Rg[[̐ݒ
	CurrentSetting		= &Setting->CurrentSetting;

	//	gbN o[̑I
	TrackBarSelecting	= FALSE;
}

//----------------------------------------------------------------------------------------------
//	wmInitDialog
//----------------------------------------------------------------------------------------------
VOID CActuatorPage::wmInitDialog( HWND Wnd )
{
	//	EBhE nh
	this->Wnd	= Wnd;

	//	uAN`G[^v
	InitTrackBar( IDC_LEFT_ACTUATOR_LEVEL, 0, 100, 10, 10 );
	//	uEAN`G[^v
	InitTrackBar( IDC_RIGHT_ACTUATOR_LEVEL, 0, 100, 10, 10 );
	//	uU̗Ĺ͈v
	InitTrackBar( IDC_ACTUATOR_THRESHOLD, 0, 100, 10, 10 );
}

//----------------------------------------------------------------------------------------------
//	wmCommand
//----------------------------------------------------------------------------------------------
VOID CActuatorPage::wmCommand(
	 HWND	Control
	,WORD	ControlID
	,WORD	NotifyMessage )
{
	//	Rg[ɂďU蕪
	switch( ControlID )
	{
		case IDC_ACTUATOR:

			//	ʒmbZ[WɂďU蕪
			switch( NotifyMessage )
			{
				case BN_CLICKED:
					//	݂̐ݒɔf
					CurrentSetting->Actuator	= GetCheckBoxState( ControlID );
					//	ݒ̕ύXʒm
					SettingChanged();
					break;
			}
			break;
	}
}

//----------------------------------------------------------------------------------------------
//	wmHScroll
//----------------------------------------------------------------------------------------------
VOID CActuatorPage::wmHScroll(
	 HWND	Control
	,WORD	Request )
{
	//	uAN`G[^ṽbZ[W
	if( Control == GetDlgItem( Wnd, IDC_LEFT_ACTUATOR_LEVEL ) )
	{
		//	݂̐ݒɔf
		CurrentSetting->ActuatorLevel[INDEX_LEFT_ACTUATOR]
			= GetTrackBarPos( IDC_LEFT_ACTUATOR_LEVEL );
		//	ݒ̕ύXʒm
		SettingChanged();
	}

	//	uEAN`G[^ṽbZ[W
	if( Control == GetDlgItem( Wnd, IDC_RIGHT_ACTUATOR_LEVEL ) )
	{
		//	݂̐ݒɔf
		CurrentSetting->ActuatorLevel[INDEX_RIGHT_ACTUATOR]
			= GetTrackBarPos( IDC_RIGHT_ACTUATOR_LEVEL );
		//	ݒ̕ύXʒm
		SettingChanged();
	}

	//	uU̗Ĺ͈ṽbZ[W
	if( Control == GetDlgItem( Wnd, IDC_ACTUATOR_THRESHOLD ) )
	{
		//	݂̑IԂޔ
		BOOL	PrevSelecting	= TrackBarSelecting;

		//	gbN o[͈̔͑Is
		SelectTrackBar( Control, Request, &TrackBarSelecting );
		if( PrevSelecting != TrackBarSelecting )
		{
			//	݂̐ݒɔf
			GetTrackBarRange(
				 IDC_ACTUATOR_THRESHOLD
				,&CurrentSetting->ActuatorMinThreshold
				,&CurrentSetting->ActuatorMaxThreshold );
			//	ݒ̕ύXʒm
			SettingChanged();
		}
	}
}

//----------------------------------------------------------------------------------------------
//	ApplySetting
//----------------------------------------------------------------------------------------------
VOID CActuatorPage::ApplySetting()
{
	//	uRg[̐Uv
	SetCheckBoxState( IDC_ACTUATOR, CurrentSetting->Actuator );
	if( CurrentSetting->Actuator == TRUE )
	{
		EnableControls( IDC_STATIC_601, IDC_STATIC_613, TRUE );
	} else {
		EnableControls( IDC_STATIC_601, IDC_STATIC_613, FALSE );
	}

	//	uAN`G[^v
	SetTrackBarPos(
		 IDC_LEFT_ACTUATOR_LEVEL
		,CurrentSetting->ActuatorLevel[INDEX_LEFT_ACTUATOR] );
	//	uEAN`G[^v
	SetTrackBarPos(
		 IDC_RIGHT_ACTUATOR_LEVEL
		,CurrentSetting->ActuatorLevel[INDEX_RIGHT_ACTUATOR] );

	//	uU̗Ĺ͈v
	SetTrackBarRange(
		 IDC_ACTUATOR_THRESHOLD
		,CurrentSetting->ActuatorMinThreshold
		,CurrentSetting->ActuatorMaxThreshold );
	SetTrackBarPos( IDC_ACTUATOR_THRESHOLD, CurrentSetting->ActuatorMinThreshold );
}
