
//	Property Sheet for Microsoft Xbox 360 Wireless Controller

#include	"advanced_page.h"
#include	"resource.h"

//----------------------------------------------------------------------------------------------
//	CAdvancedPage
//----------------------------------------------------------------------------------------------
CAdvancedPage::CAdvancedPage( CSetting * Setting )
{
	//	ݒ
	this->Setting		= Setting;

	//	݂̃Rg[[̐ݒ
	CurrentSetting		= &Setting->CurrentSetting;
}

//----------------------------------------------------------------------------------------------
//	wmInitDialog
//----------------------------------------------------------------------------------------------
VOID CAdvancedPage::wmInitDialog( HWND Wnd )
{
	//	EBhE nh
	this->Wnd	= Wnd;

	//	@\̈ꗗ
	WORD	SliderList[]	= {	 IDS_Z_AXIS
								,IDS_Z_ROTATION
								,IDS_SLIDER1
								,IDS_SLIDER2 };
	WORD	SliderListCount	= sizeof( SliderList ) / sizeof( WORD ) ;

	//	݊[h
	WORD	LimitationMode[]	= {	 IDS_LIMITATION_MODE_0
									,IDS_LIMITATION_MODE_1
									,IDS_LIMITATION_MODE_2
									,IDS_LIMITATION_MODE_3 };
	WORD	LimitationModeCount	= sizeof( LimitationMode ) / sizeof( WORD ) ;

	//	Rg[[
	WORD	ControllerCount[]	= {	 IDS_CONTROLLER_COUNT_1
									,IDS_CONTROLLER_COUNT_2
									,IDS_CONTROLLER_COUNT_3
									,IDS_CONTROLLER_COUNT_4 };
	WORD	ControllerCountCount	= sizeof( ControllerCount ) / sizeof( WORD ) ;

	//	u@\̈ꗗv
	InitListBox(
		 IDC_SLIDER_LIST
		,SliderList
		,SliderListCount );
	SetListBoxIndex( IDC_SLIDER_LIST, 0 );
	//	u݊[hv
	InitComboBox(
		 IDC_LIMITATION_MODE
		,LimitationMode
		,LimitationModeCount );
	//	uRg[[v
	InitComboBox(
		 IDC_CONTROLLER_COUNT
		,ControllerCount
		,ControllerCountCount );
}

//----------------------------------------------------------------------------------------------
//	wmCommand
//----------------------------------------------------------------------------------------------
VOID CAdvancedPage::wmCommand(
	 HWND	Control
	,WORD	ControlID
	,WORD	NotifyMessage )
{
	//	Rg[ɂďU蕪
	switch( ControlID )
	{
		case IDC_SLIDER_LIST:

			//	ʒmbZ[WɂďU蕪
			switch( NotifyMessage )
			{
				case LBN_SELCHANGE:
					ApplySetting();
					break;
			}
			break;

		case IDC_SLIDE_SLIDER_VALUE:

			//	ʒmbZ[WɂďU蕪
			switch( NotifyMessage )
			{
				case BN_CLICKED:
					//	݂̐ݒɔf
					CurrentSetting->SlideSliderValue[GetListBoxIndex( IDC_SLIDER_LIST )]
						= GetCheckBoxState( ControlID );
					//	ݒ̕ύXʒm
					SettingChanged();
					break;
			}
			break;

		case IDC_SLIDE_SLIDER_CENTER_VALUE:

			//	ʒmbZ[WɂďU蕪
			switch( NotifyMessage )
			{
				case BN_CLICKED:
					//	݂̐ݒɔf
					CurrentSetting->SlideSliderCenterValue[GetListBoxIndex( IDC_SLIDER_LIST )]
						= GetCheckBoxState( ControlID );
					//	ݒ̕ύXʒm
					SettingChanged();
					break;
			}
			break;

		case IDC_REVERSE_SLIDER_VALUE:

			//	ʒmbZ[WɂďU蕪
			switch( NotifyMessage )
			{
				case BN_CLICKED:
					//	݂̐ݒɔf
					CurrentSetting->ReverseSliderValue[GetListBoxIndex( IDC_SLIDER_LIST )]
						= GetCheckBoxState( ControlID );
					//	ݒ̕ύXʒm
					SettingChanged();
					break;
			}
			break;

		case IDC_LIMITATION_MODE:

			//	ʒmbZ[WɂďU蕪
			switch( NotifyMessage )
			{
				case CBN_SELCHANGE:
					//	݂̐ݒɔf
					CurrentSetting->LimitationMode	= GetComboBoxIndex( ControlID );
					//	ݒ̕ύXʒm
					SettingChanged();
					break;
			}
			break;

		case IDC_STICK_DEAD_ZONE_TYPE_SQUARE:

			//	ʒmbZ[WɂďU蕪
			switch( NotifyMessage )
			{
				case BN_CLICKED:
					//	݂̐ݒɔf
					CurrentSetting->StickDeadZoneType[INDEX_LEFT_STICK]	= DEAD_ZONE_TYPE_SQUARE;
					CurrentSetting->StickDeadZoneType[INDEX_RIGHT_STICK]
						= CurrentSetting->StickDeadZoneType[INDEX_LEFT_STICK];
					//	ݒ̕ύXʒm
					SettingChanged();
					break;
			}
			break;

		case IDC_STICK_DEAD_ZONE_TYPE_CIRCLE:

			//	ʒmbZ[WɂďU蕪
			switch( NotifyMessage )
			{
				case BN_CLICKED:
					//	݂̐ݒɔf
					CurrentSetting->StickDeadZoneType[INDEX_LEFT_STICK]	= DEAD_ZONE_TYPE_CIRCLE;
					CurrentSetting->StickDeadZoneType[INDEX_RIGHT_STICK]
						= CurrentSetting->StickDeadZoneType[INDEX_LEFT_STICK];
					//	ݒ̕ύXʒm
					SettingChanged();
					break;
			}
			break;

		case IDC_TRANSFORM_TYPE_SQUARE:

			//	ʒmbZ[WɂďU蕪
			switch( NotifyMessage )
			{
				case BN_CLICKED:
					//	݂̐ݒɔf
					if( GetCheckBoxState( ControlID ) == BST_CHECKED )
					{
						CurrentSetting->StickTransformType[INDEX_LEFT_STICK]
							= TRANSFORM_TYPE_SQUARE;
						CurrentSetting->StickTransformType[INDEX_RIGHT_STICK]
							= TRANSFORM_TYPE_SQUARE;
						SetCheckBoxState( IDC_TRANSFORM_TYPE_CIRCLE, BST_UNCHECKED );
					} else {
						CurrentSetting->StickTransformType[INDEX_LEFT_STICK]
							= TRANSFORM_TYPE_NONE;
						CurrentSetting->StickTransformType[INDEX_RIGHT_STICK]
							= TRANSFORM_TYPE_NONE;
					}
					//	ݒ̕ύXʒm
					SettingChanged();
					break;
			}
			break;

		case IDC_TRANSFORM_TYPE_CIRCLE:

			//	ʒmbZ[WɂďU蕪
			switch( NotifyMessage )
			{
				case BN_CLICKED:
					//	݂̐ݒɔf
					if( GetCheckBoxState( ControlID ) == BST_CHECKED )
					{
						CurrentSetting->StickTransformType[INDEX_LEFT_STICK]
							= TRANSFORM_TYPE_CIRCLE;
						CurrentSetting->StickTransformType[INDEX_RIGHT_STICK]
							= TRANSFORM_TYPE_CIRCLE;
						SetCheckBoxState( IDC_TRANSFORM_TYPE_SQUARE, BST_UNCHECKED );
					} else {
						CurrentSetting->StickTransformType[INDEX_LEFT_STICK]
							= TRANSFORM_TYPE_NONE;
						CurrentSetting->StickTransformType[INDEX_RIGHT_STICK]
							= TRANSFORM_TYPE_NONE;
					}
					//	ݒ̕ύXʒm
					SettingChanged();
					break;
			}
			break;

		case IDC_CONTROLLER_COUNT:

			//	ʒmbZ[WɂďU蕪
			switch( NotifyMessage )
			{
				case CBN_SELCHANGE:
					//	݂̐ݒɔf
					CurrentSetting->ControllerCount	= GetComboBoxIndex( ControlID ) + 1;
					//	ݒ̕ύXʒm
					SettingChanged();
					break;
			}
			break;
	}
}

//----------------------------------------------------------------------------------------------
//	ApplySetting
//----------------------------------------------------------------------------------------------
VOID CAdvancedPage::ApplySetting()
{
	//	uXeBbN̗Ĺ͈v
	if( CurrentSetting->StickDeadZoneType[INDEX_LEFT_STICK] == DEAD_ZONE_TYPE_SQUARE )
	{
		SetCheckBoxState( IDC_STICK_DEAD_ZONE_TYPE_SQUARE, BST_CHECKED );
		SetCheckBoxState( IDC_STICK_DEAD_ZONE_TYPE_CIRCLE, BST_UNCHECKED );
	} else {
		SetCheckBoxState( IDC_STICK_DEAD_ZONE_TYPE_SQUARE, BST_UNCHECKED );
		SetCheckBoxState( IDC_STICK_DEAD_ZONE_TYPE_CIRCLE, BST_CHECKED );
	}

	//	uXeBbN̉͈́v
	if( CurrentSetting->StickTransformType[INDEX_LEFT_STICK] == TRANSFORM_TYPE_NONE )
	{
		SetCheckBoxState( IDC_TRANSFORM_TYPE_SQUARE, BST_UNCHECKED );
		SetCheckBoxState( IDC_TRANSFORM_TYPE_CIRCLE, BST_UNCHECKED );
	}
	if( CurrentSetting->StickTransformType[INDEX_LEFT_STICK] == TRANSFORM_TYPE_SQUARE )
	{
		SetCheckBoxState( IDC_TRANSFORM_TYPE_SQUARE, BST_CHECKED );
		SetCheckBoxState( IDC_TRANSFORM_TYPE_CIRCLE, BST_UNCHECKED );
	}
	if( CurrentSetting->StickTransformType[INDEX_LEFT_STICK] == TRANSFORM_TYPE_CIRCLE )
	{
		SetCheckBoxState( IDC_TRANSFORM_TYPE_SQUARE, BST_UNCHECKED );
		SetCheckBoxState( IDC_TRANSFORM_TYPE_CIRCLE, BST_CHECKED );
	}

	//	u@\̈ꗗv
	LONG	ListBoxIndex	= GetListBoxIndex( IDC_SLIDER_LIST );
	//	uSɂv
	SetCheckBoxState( IDC_SLIDE_SLIDER_VALUE, CurrentSetting->SlideSliderValue[ListBoxIndex] );
	//	uS̊l炷v
	SetCheckBoxState(
		 IDC_SLIDE_SLIDER_CENTER_VALUE
		,CurrentSetting->SlideSliderCenterValue[ListBoxIndex] );
	//	ul𔽓]v
	SetCheckBoxState(
		 IDC_REVERSE_SLIDER_VALUE
		,CurrentSetting->ReverseSliderValue[ListBoxIndex] );

	//	u݊[hv
	SetComboBoxIndex( IDC_LIMITATION_MODE, CurrentSetting->LimitationMode );

	//	uRg[[v
	SetComboBoxIndex( IDC_CONTROLLER_COUNT, CurrentSetting->ControllerCount - 1 );
}
