
//	Property Sheet for Microsoft Xbox 360 Wireless Controller

#include	"controller_page.h"
#include	"extension.h"
#include	"save_dialog.h"
#include	"resource.h"

//----------------------------------------------------------------------------------------------
//	CControllerPage
//----------------------------------------------------------------------------------------------
CControllerPage::CControllerPage( CSetting * Setting )
{
	//	ݒ
	this->Setting	= Setting;

	//	݂̃Rg[[̐ݒ
	CurrentSetting	= &Setting->CurrentSetting;

	//	foCXɓKpĂZbeBOޔ
	CopyMemory( &DeviceSetting, CurrentSetting, sizeof( SETTING ) );

	//	eCX^X쐬
	Device			= new CDevice();
	Report			= new CReport();
}

//----------------------------------------------------------------------------------------------
//	wmInitDialog
//----------------------------------------------------------------------------------------------
VOID CControllerPage::wmInitDialog( HWND Wnd )
{
	//	EBhE nh
	this->Wnd	= Wnd;

	//	Xe[^X GA ACRƂ̔rs
	Mutex	= CreateMutex( NULL, TRUE, X360WCPS_MUTEX );

	//	uUv
	InitTrackBar( IDC_FORCE_FEEDBACK, 0, 100, 10, 10 );

	//	|[Op^C}[Jn
	SetTimer( Wnd, POLLING_TIMER_ID, POLLING_INTERVAL, NULL );
}

//----------------------------------------------------------------------------------------------
//	wmCommand
//----------------------------------------------------------------------------------------------
VOID CControllerPage::wmCommand(
	 HWND	Control
	,WORD	ControlID
	,WORD	NotifyMessage )
{
	//	Rg[ɂďU蕪
	switch( ControlID )
	{
		case IDC_SETTING:

			//	ʒmbZ[WɂďU蕪
			switch( NotifyMessage )
			{
				case CBN_SELCHANGE:
					//	ݒύX
					ChangeSetting();
					break;
			}
			break;

		case IDC_SETTING_SAVE:

			//	ʒmbZ[WɂďU蕪
			switch( NotifyMessage )
			{
				case BN_CLICKED:
					//	ݒۑ
					SaveSetting();
					break;
			}
			break;

		case IDC_SETTING_DELETE:

			//	ʒmbZ[WɂďU蕪
			switch( NotifyMessage )
			{
				case BN_CLICKED:
					//	ݒ폜
					DeleteSetting();
					break;
			}
			break;
	}
}

//----------------------------------------------------------------------------------------------
//	wmNotify
//----------------------------------------------------------------------------------------------
VOID CControllerPage::wmNotify( NMHDR * Notify )
{
	//	ʒmbZ[WɂďU蕪
	switch( Notify->code )
	{
		case PSN_APPLY:
			//	݊̐ݒ肪ςĂ΃_CAO\
			if( ( DeviceSetting.ControllerCount	!= CurrentSetting->ControllerCount )
			||	( DeviceSetting.LimitationMode	!= CurrentSetting->LimitationMode ) )
			{
				ShowMessageBox(
					 IDS_RESTART_TITLE
					,IDS_RESTART_MESSAGE
					,NULL
					,MB_OK | MB_ICONINFORMATION );
			}

			//	Rg[[̐ݒύX
			Setting->SaveRegistry();
			Device->Apply();

			//	Xe[^X GA ACRɕύXʒm
			SendMessage(
				 FindWindow( X360WCSAI_CLASS_NAME, NULL )
				,WM_STATUS_AREA_ICON_NOTIFY
				,UPDATE_SETTING
				,NULL );

			//	vpeB V[g
			if( ((PSHNOTIFY *)Notify)->lParam == TRUE )
			{
				ClosePage();
			}
			break;

		case PSN_RESET:
			//	vpeB V[g
			ClosePage();
			break;
	}
}

//----------------------------------------------------------------------------------------------
//	wmTimer
//----------------------------------------------------------------------------------------------
VOID CControllerPage::wmTimer( WPARAM TimerId )
{
	switch( TimerId )
	{
		case POLLING_TIMER_ID:
			//	|[Op^C}[~
			KillTimer( Wnd, TimerId );

			//	Rg[[̏Ԃ\
			ShowControllerState();

			//	UeXg
			if( CurrentSetting->Actuator == TRUE )
			{
				//	eXgl擾
				LONG TestLevel	= (LONG)SendMessage(
									 GetDlgItem( Wnd, IDC_FORCE_FEEDBACK )
									,TBM_GETPOS
									,0
									,0 ) * 255 / 100;
				//	UeXg
				TestForceFeedback( TestLevel );
			} else {
				//	UeXg
				TestForceFeedback( 0 );
			}

			//	|[Op^C}[Jn
			SetTimer( Wnd, POLLING_TIMER_ID, POLLING_INTERVAL, NULL );
			break;
	}
}

//----------------------------------------------------------------------------------------------
//	wmPageChanged
//----------------------------------------------------------------------------------------------
VOID CControllerPage::wmPageChanged()
{
	//	ύXꂽݒ𔽉f
	ApplyChangedSetting();
}

//----------------------------------------------------------------------------------------------
//	ApplySetting
//----------------------------------------------------------------------------------------------
VOID CControllerPage::ApplySetting()
{
	//	ϐ錾
	BOOL	Different	= FALSE;

	//	R{ {bNX̓eقȂ邩`FbN
	HWND	ComboBox		= GetDlgItem( Wnd, IDC_SETTING );
	LONG	ItemCount		= (LONG)SendMessage( ComboBox, CB_GETCOUNT, 0, 0 );
	if( Setting->ModifiedFlag == TRUE )
	{
		ItemCount --;
	}
	if( ItemCount == Setting->SettingCount )
	{
		//	ACe̕`FbN
		for( LONG Index = 0; Index < Setting->SettingCount; Index ++ )
		{
			//	R{ {bNX̕擾
			WCHAR	Text[MAX_PATH]	= { '\n' };
			if( Setting->ModifiedFlag == TRUE )
			{
				SendMessage( ComboBox, CB_GETLBTEXT, Index + 1, (LPARAM)Text );
			} else {
				SendMessage( ComboBox, CB_GETLBTEXT, Index, (LPARAM)Text );
			}
			if( wcscmp( Setting->SettingName[Index], Text ) != 0 )
			{
				Different	= TRUE;
				break;
			}
		}
	} else {
		Different	= TRUE;
	}

	//	R{ {bNX̓eݒ肷
	if( Different == TRUE )
	{
		//	R{ {bNX̓eZbg
		SendMessage( ComboBox, CB_RESETCONTENT, 0, 0 );

		//	ݒ薼̂R{ {bNXɑ}
		for( LONG Index = 0; Index < Setting->SettingCount; Index ++ )
		{
			SendMessage(
				 ComboBox
				,CB_INSERTSTRING
				,Index
				,(LPARAM)Setting->SettingName[Index] );
		}

		//	ݒ肪ύXς݂ȂԏɁu` (ύXς)v}
		if( Setting->ModifiedFlag == TRUE )
		{
			//	ݒ薼̂擾
			WCHAR	SettingName[MAX_PATH * 2];
			wcscpy_s( SettingName, Setting->SettingName[Setting->CurrentSettingIndex] );

			//	\[Xu(ύXς)v擾Aݒ薼̂ɕt
			WCHAR	Modified[MAX_PATH];
			LoadString( Instance, IDS_MODIFIED, Modified, MAX_PATH );
			wcscat_s( SettingName, Modified );

			//	ύXς݂̐ݒ薼̂R{ {bNẌԏɑ}
			SendMessage( ComboBox, CB_INSERTSTRING, 0, (LPARAM)SettingName );
		}
	}

	//	R{ {bNX̏Ԃݒ肷
	if( Setting->ModifiedFlag == FALSE )
	{
		SetComboBoxIndex( IDC_SETTING, (UCHAR)Setting->CurrentSettingIndex );
	} else {
		SetComboBoxIndex( IDC_SETTING, 0 );
	}
	//	폜{^̗LAݒ肷
	if( Setting->ModifiedFlag == FALSE && Setting->CurrentSettingIndex > 0 )
	{
		EnableControl( IDC_SETTING_DELETE, TRUE );
	} else {
		EnableControl( IDC_SETTING_DELETE, FALSE );
	}
}

//----------------------------------------------------------------------------------------------
//	ChangeSetting
//----------------------------------------------------------------------------------------------
VOID CControllerPage::ChangeSetting()
{
	//	ϐ錾
	LONG	MsgResult;

	//	ύXς݂ǂŏU蕪
	if( Setting->ModifiedFlag == TRUE )
	{
		//	ԂIȂ牽Ȃ
		if( GetComboBoxIndex( IDC_SETTING ) == 0 )
		{
			return;
		}

		//	_CAO\AU蕪
		MsgResult	= ShowMessageBox(
						 IDS_SAVE_TITLE
						,IDS_SAVE_MESSAGE
						,NULL
						,MB_YESNOCANCEL | MB_ICONQUESTION );
		switch( MsgResult )
		{
			case IDYES:
				//	Rg[[̐ݒۑ
				MsgResult	= (LONG)DialogBoxParam(
								 Instance
								,MAKEINTRESOURCE( IDD_SAVE_DIALOG )
								,Wnd
								,(DLGPROC)SaveDialogProc
								,(LPARAM)Setting );
				if( MsgResult == IDOK )
				{
					//	ύXꂽݒ𔽉f
					ApplyChangedSetting();
				}
				if( MsgResult == IDCANCEL )
				{
					//	LZȂRg[[̐ݒ 0 ɖ߂
					SetComboBoxIndex( IDC_SETTING, 0 );
				}
				break;

			case IDNO:
				//	Rg[[̐ݒύX
				Setting->ModifiedFlag	= FALSE;
				Setting->Change( GetComboBoxIndex( IDC_SETTING ) - 1, TRUE );
				//	ύXꂽݒ𔽉f
				ApplyChangedSetting();
				break;

			case IDCANCEL:
				//	LZȂRg[[̐ݒ 0 ɖ߂
				SetComboBoxIndex( IDC_SETTING, 0 );
				break;
		}

	} else {
		//	ԂIȂ牽Ȃ
		if( GetComboBoxIndex( IDC_SETTING ) == Setting->CurrentSettingIndex )
		{
			return;
		}

		//	IꂽݒɕύX
		Setting->Change( GetComboBoxIndex( IDC_SETTING ), TRUE );
		//	ύXꂽݒ𔽉f
		ApplyChangedSetting();
	}
}

//----------------------------------------------------------------------------------------------
//	SaveSetting
//----------------------------------------------------------------------------------------------
VOID CControllerPage::SaveSetting()
{
	//	_CAO {bNX\Aݒۑ
	LONG	MsgResult	= (LONG)DialogBoxParam(
							 Instance
							,MAKEINTRESOURCE( IDD_SAVE_DIALOG )
							,Wnd
							,(DLGPROC)SaveDialogProc
							,(LPARAM)Setting );
	if( MsgResult == IDOK )
	{
		//	ύXꂽݒ𔽉f
		ApplyChangedSetting();
	}
}

//----------------------------------------------------------------------------------------------
//	DeleteSetting
//----------------------------------------------------------------------------------------------
VOID CControllerPage::DeleteSetting()
{
	//	bZ[W\Aݒ̍폜mF
	LONG	Result	= ShowMessageBox(
						 IDS_DELETE_TITLE
						,IDS_DELETE_MESSAGE
						,Setting->SettingName[Setting->CurrentSettingIndex]
						,MB_YESNO | MB_ICONQUESTION );
	if( Result == IDYES )
	{
		//	IĂݒ폜
		Setting->Delete();
		//	ύXꂽݒ𔽉f
		ApplyChangedSetting();
	}
}

//----------------------------------------------------------------------------------------------
//	ApplyChangedSetting
//----------------------------------------------------------------------------------------------
VOID CControllerPage::ApplyChangedSetting()
{
	//	ϐ錾
	HWND	Dialog	= GetParent( Wnd );

	//	ݒ𔽉f
	ApplySetting();

	//	ey[Wɐݒ𔽉f
	for( LONG Index = 1; Index < 7; Index ++ )
	{
		HWND	Page	= PropSheet_IndexToHwnd( Dialog, Index );
		if( Page != NULL )
		{
			SendMessage(
				 Page
				,WM_SETTING_LIST_CHANGED
				,NULL
				,NULL );
		}
	}

	//	vpeB V[gɕύXʒm
	PropSheet_Changed( Dialog, Wnd );
}

//----------------------------------------------------------------------------------------------
//	ClosePage
//----------------------------------------------------------------------------------------------
VOID CControllerPage::ClosePage()
{
	//	|[Op^C}[~
	KillTimer( Wnd, POLLING_TIMER_ID );

	//	U~
	TestForceFeedback( 0 );

	//	eCX^XJ
	delete	Device;
	delete	Report;

	//	~[ebNXJ
	CloseHandle( Mutex );
}

//----------------------------------------------------------------------------------------------
//	ShowControllerState
//----------------------------------------------------------------------------------------------
VOID CControllerPage::ShowControllerState()
{
	//	Rg[[݂̌̏Ԃ擾
	FEATURE_REPORT_ID	FeatureReport;
	ZeroMemory( &FeatureReport, sizeof( FEATURE_REPORT_ID ) );
	Device->GetState( &FeatureReport );

	//	̓|[g쐬iACg̊֌W|C^n肭Ȃj
	INPUT_REPORT	InputReport;
	InputReport.DigitalButton	= FeatureReport.DigitalButton;
	InputReport.LeftTrigger		= FeatureReport.LeftTrigger;
	InputReport.RightTrigger	= FeatureReport.RightTrigger;
	InputReport.LeftStickX		= FeatureReport.LeftStickX;
	InputReport.LeftStickY		= FeatureReport.LeftStickY;
	InputReport.RightStickX		= FeatureReport.RightStickX;
	InputReport.RightStickY		= FeatureReport.RightStickY;

	//	HID Ǎp|[g𐶐
	HID_READ_REPORT	ReadReport;
	ZeroMemory( &ReadReport, sizeof( HID_READ_REPORT ) );
	Report->GenerateReadReport(
		 (INPUT_REPORT *)&InputReport
		,CurrentSetting
		,&ReadReport
		,&LastState );

	//	ꂽRg[[̏Ԃ\
	SetIntegerText( IDC_X_AXIS, ReadReport.XAxis );
	SetIntegerText( IDC_Y_AXIS, ReadReport.YAxis );
	SetIntegerText( IDC_X_ROTATION, ReadReport.XRotation );
	SetIntegerText( IDC_Y_ROTATION, ReadReport.YRotation );
	SetIntegerText( IDC_Z_AXIS, ReadReport.ZAxis );
	SetIntegerText( IDC_Z_ROTATION, ReadReport.ZRotation );
	SetIntegerText( IDC_SLIDER1, ReadReport.Slider1 );
	SetIntegerText( IDC_SLIDER2, ReadReport.Slider2 );
	SetIntegerText(
		 IDC_HAT_SWITCH1
		,ReadReport.HatSwitch1 != -1 ? ReadReport.HatSwitch1 * 45 : -1 );
	SetIntegerText(
		 IDC_HAT_SWITCH2
		,ReadReport.HatSwitch2 != -1 ? ReadReport.HatSwitch2 * 45 : -1 );
	SetIntegerText(
		 IDC_HAT_SWITCH3
		,ReadReport.HatSwitch3 != -1 ? ReadReport.HatSwitch3 * 45 : -1 );
	SetIntegerText(
		 IDC_HAT_SWITCH4
		,ReadReport.HatSwitch4 != -1 ? ReadReport.HatSwitch4 * 45 : -1 );
	SetButtonNumberText( IDC_BUTTON, ReadReport.Buttons );
}

//----------------------------------------------------------------------------------------------
//	TestForceFeedback
//----------------------------------------------------------------------------------------------
VOID CControllerPage::TestForceFeedback( LONG TestLevel )
{
	//	|[g쐬
	HID_WRITE_REPORT_ID	WriteReport;
	ZeroMemory( &WriteReport, sizeof( HID_WRITE_REPORT_ID ) );
	WriteReport.Id		= 0;
	WriteReport.Type	= REPORT_TYPE_DIRECT;
	Report->SetActuator(
		 TestLevel
		,CurrentSetting->ActuatorLevel[INDEX_LEFT_ACTUATOR]
		,CurrentSetting->ActuatorMinThreshold
		,CurrentSetting->ActuatorMaxThreshold
		,&WriteReport.Left );
	Report->SetActuator(
		 TestLevel
		,CurrentSetting->ActuatorLevel[INDEX_RIGHT_ACTUATOR]
		,CurrentSetting->ActuatorMinThreshold
		,CurrentSetting->ActuatorMaxThreshold
		,&WriteReport.Right );

	//	foCXɐݒ肷
	Device->SetState( &WriteReport );
}
