
//	Property Sheet for Microsoft Xbox 360 Wireless Controller

#include	"extension.h"
#include	"com.h"

//----------------------------------------------------------------------------------------------
//	O[oϐ
//----------------------------------------------------------------------------------------------

HINSTANCE			Instance;
CRITICAL_SECTION	CriticalSection;

//----------------------------------------------------------------------------------------------
//	DllMain
//----------------------------------------------------------------------------------------------
BOOL WINAPI DllMain(
	 HINSTANCE	ThisInstance
	,DWORD		Reason
	,LPVOID		Reserved )
{
	switch( Reason )
	{
		case DLL_PROCESS_ATTACH:
			//	NeBJ ZNV
			Instance	= ThisInstance;
			InitializeCriticalSection( &CriticalSection );
			break;

		case DLL_PROCESS_DETACH:
			//	NeBJ ZNV폜
			DeleteCriticalSection( &CriticalSection );
			break;
	}

	return( TRUE );
}

//----------------------------------------------------------------------------------------------
//	DllGetClassObject
//----------------------------------------------------------------------------------------------
STDAPI DllGetClassObject(
	 REFCLSID	ClassID
	,REFIID		InterfaceID
	,LPVOID *	Interface )
{
	//	ϐ錾
	HRESULT	Result	= S_OK;

	//	IClassFactory 쐬
	if( IsEqualGUID( ClassID, ClassID_X360WCPS ) )
	{
		CClassFactory *	Factory	= new CClassFactory();
		if( Factory != NULL )
		{
			Result	= Factory->QueryInterface( InterfaceID, Interface );
			Factory->Release();
		} else {
			Result	= E_OUTOFMEMORY;
		}
	} else {
		Result	= CLASS_E_CLASSNOTAVAILABLE;
	}

	return( Result );
}

//----------------------------------------------------------------------------------------------
//	DllCanUnloadNow
//----------------------------------------------------------------------------------------------
STDAPI DllCanUnloadNow( VOID )
{
	return( S_OK );
}
