
//	Property Sheet for Microsoft Xbox 360 Wireless Controller

#include	"setting.h"
#include	"resource.h"

//----------------------------------------------------------------------------------------------
//	CSetting
//----------------------------------------------------------------------------------------------
CSetting::CSetting(
	 HINSTANCE	Instance
	,HWND		Wnd )
{
	//	CX^X
	this->Instance	= Instance;
	//	EBhE nh
	this->Wnd		= Wnd;

	//	Rg[[̐ݒ
	Setting			= NULL;
	//	Rg[[̐ݒ̖
	SettingName		= NULL;

	//	WXgݒǂݍ
	LoadRegistry();
}

//----------------------------------------------------------------------------------------------
//	~CSetting
//----------------------------------------------------------------------------------------------
CSetting::~CSetting()
{
	//	Rg[[̐ݒAݒ̖̗̂̈J
	if( Setting != NULL )
	{
		LocalFree( Setting );
	}
	if( SettingName != NULL )
	{
		for( LONG Index = 0; Index < SettingCount; Index ++ )
		{
			LocalFree( SettingName[Index] );
		}
		LocalFree( SettingName );
	}
}

//----------------------------------------------------------------------------------------------
//	LoadRegistry
//----------------------------------------------------------------------------------------------
VOID CSetting::LoadRegistry()
{
	//	Rg[[̐ݒAݒ̖̗̂̈J
	if( Setting != NULL )
	{
		LocalFree( Setting );
	}
	if( SettingName != NULL )
	{
		for( LONG Index = 0; Index < SettingCount; Index ++ )
		{
			LocalFree( SettingName[Index] );
		}
		LocalFree( SettingName );
	}

	//	݂̃Rg[[̐ݒ擾
	GetDefaultSetting( &CurrentSetting );
	GetRegistry( &CurrentSetting, REG_BINARY, sizeof( SETTING ), CURRENT_SETTING );

	//	݂̃Rg[[̐ݒ̏Ԃ擾
	CurrentSettingIndex	= 0;
	GetRegistry( &CurrentSettingIndex, REG_DWORD, sizeof( LONG ), CURRENT_SETTING_INDEX );

	//	Rg[[̐ݒ萔擾
	SettingCount	= 1;
	GetRegistry( &SettingCount, REG_DWORD, sizeof( LONG ), SETTING_COUNT );

	//	Rg[[̐ݒAݒ̖̂ۑ邽߂̗̈mۂ
	Setting		= (SETTING *)LocalAlloc( LPTR, SettingCount * sizeof( SETTING ) );
	SettingName	= (WCHAR * *)LocalAlloc( LPTR, SettingCount * sizeof( WCHAR * ) );
	for( LONG Index = 0; Index < SettingCount; Index ++ )
	{
		SettingName[Index]	= (WCHAR *)LocalAlloc( LPTR, sizeof( WCHAR ) * MAX_PATH );
	}

	//	W̐ݒ擾
	GetDefaultSetting( &Setting[0] );
	LoadString( Instance, IDS_DEFAULT_SETTING, SettingName[0], sizeof( WCHAR ) * MAX_PATH );

	//	Rg[[̐ݒAݒ̖̂擾
	for( LONG Index = 1; Index < SettingCount; Index ++ )
	{
		GetSetting( Index, &Setting[Index] );
		GetSettingName( Index, SettingName[Index], sizeof( WCHAR ) * MAX_PATH );
	}

	//	ύXς݃tO擾
	ModifiedFlag	= FALSE;
	GetRegistry( &ModifiedFlag, REG_BINARY, sizeof( BOOLEAN ), MODIFIED_FLAG );

	//	ݒ̎؊擾
	AutoSettingChange	= FALSE;
	GetRegistry( &AutoSettingChange, REG_BINARY, sizeof( BOOLEAN ), AUTO_SETTING_CHANGE );
}

//----------------------------------------------------------------------------------------------
//	SaveRegistry
//----------------------------------------------------------------------------------------------
VOID CSetting::SaveRegistry()
{
	//	݂̃Rg[[̐ݒXV
	SetRegistry( &CurrentSetting, REG_BINARY, sizeof( SETTING ), CURRENT_SETTING );

	//	݂̃Rg[[̐ݒ̏ԂXV
	SetRegistry( &CurrentSettingIndex, REG_DWORD, sizeof( LONG ), CURRENT_SETTING_INDEX );

	//	Rg[[̐ݒ萔擾Ă
	LONG	OldSettingCount	= 0;
	GetRegistry( &OldSettingCount, REG_DWORD, sizeof( LONG ), SETTING_COUNT );

	//	Rg[[̐ݒ萔XV
	SetRegistry( &SettingCount, REG_DWORD, sizeof( LONG ), SETTING_COUNT );

	//	Rg[[̐ݒAݒ̖̂XV
	for( LONG Index = 1; Index < SettingCount; Index ++ )
	{
		SetSetting( Index, &Setting[Index] );
		SetSettingName( Index, SettingName[Index] );
	}

	//	]ȃRg[[̐ݒAݒ̖̂폜
	if( OldSettingCount > SettingCount )
	{
		for( LONG Index = SettingCount; Index < OldSettingCount; Index ++ )
		{
			DelSetting( Index );
			DelSettingName( Index );
		}
	}

	//	ύXς݃tOXV
	SetRegistry( &ModifiedFlag, REG_BINARY, sizeof( BOOLEAN ), MODIFIED_FLAG );

	//	ݒ̎؊XV
	SetRegistry( &AutoSettingChange, REG_BINARY, sizeof( BOOLEAN ), AUTO_SETTING_CHANGE );
}

//----------------------------------------------------------------------------------------------
//	SaveAs
//----------------------------------------------------------------------------------------------
VOID CSetting::SaveAs( WCHAR * SaveName )
{
	//	݂̃Rg[[̐ݒ̏ԂXV
	CurrentSettingIndex	= SettingCount;

	//	Rg[[̐ݒ萔XV
	SettingCount ++;

	//	Rg[[̐ݒǉ
	Setting	= (SETTING *)LocalReAlloc(
				 Setting
				,SettingCount * sizeof( SETTING )
				,LMEM_MOVEABLE );
	CopyMemory( &Setting[CurrentSettingIndex], &CurrentSetting, sizeof( SETTING ) );
	//	Rg[[̐ݒ̖̂ǉ
	SettingName	= (WCHAR * *)LocalReAlloc(
					 SettingName
					,SettingCount * sizeof( WCHAR * )
					,LMEM_MOVEABLE );
	SettingName[CurrentSettingIndex]	= (WCHAR *)LocalAlloc(
											  LPTR
											 ,sizeof( WCHAR ) * MAX_PATH );
	wcscpy_s( SettingName[CurrentSettingIndex], MAX_PATH, SaveName );

	//	ύXς݃tOXV
	ModifiedFlag	= FALSE;
}

//----------------------------------------------------------------------------------------------
//	Save
//----------------------------------------------------------------------------------------------
VOID CSetting::Save( LONG Index )
{
	//	݂̃Rg[[̐ݒ̏ԂXV
	CurrentSettingIndex	= Index;

	//	Rg[[̐ݒXV
	CopyMemory( &Setting[CurrentSettingIndex], &CurrentSetting, sizeof( SETTING ) );

	//	ύXς݃tOXV
	ModifiedFlag	= FALSE;
}

//----------------------------------------------------------------------------------------------
//	Delete
//----------------------------------------------------------------------------------------------
VOID CSetting::Delete()
{
	//	Rg[[̐ݒ萔XV
	SettingCount --;
	if( CurrentSettingIndex < SettingCount )
	{
		//	Rg[[̐ݒAݒ̖̂PXCh
		MoveMemory(
			 &Setting[CurrentSettingIndex]
			,&Setting[CurrentSettingIndex + 1]
			,sizeof( SETTING ) * ( SettingCount - CurrentSettingIndex ) );
		LocalFree( SettingName[CurrentSettingIndex] );
		MoveMemory(
			 &SettingName[CurrentSettingIndex]
			,&SettingName[CurrentSettingIndex + 1]
			,sizeof( WCHAR * ) * ( SettingCount - CurrentSettingIndex ) );
	} else {
		//	݂̃Rg[[̐ݒ̏ԂXV
		CurrentSettingIndex --;
	}
	//	݂̃Rg[[̐ݒXV
	CopyMemory( &CurrentSetting, &Setting[CurrentSettingIndex], sizeof( SETTING ) );
	//	svȃJ
	Setting	= (SETTING *)LocalReAlloc(
				 Setting
				,SettingCount * sizeof( SETTING )
				,LMEM_MOVEABLE );
	SettingName	= (WCHAR * *)LocalReAlloc(
					 SettingName
					,SettingCount * sizeof( WCHAR * )
					,LMEM_MOVEABLE );

	//	ύXς݃tOXV
	ModifiedFlag	= FALSE;
}

//----------------------------------------------------------------------------------------------
//	Change
//----------------------------------------------------------------------------------------------
VOID CSetting::Change(
	 LONG	Index
	,BOOL	Auto )
{
	//	ύXς݂ȂmF
	LONG	MsgResult	= IDYES;
	if( ModifiedFlag == TRUE )
	{
		if( Auto == TRUE )
		{
			MsgResult	= IDNO;
		} else {
			MsgResult	= ShowMessageBox(
							 Wnd
							,IDS_WARNING_TITLE
							,IDS_WARNING_MESSAGE
							,MB_YESNO | MB_ICONQUESTION );
		}
	}

	//	Rg[[̐ݒύX
	if( MsgResult == IDYES )
	{
		//	݊̐ݒ肪ςĂ΃_CAO\
		if( Auto == FALSE )
		{
			if(	CurrentSetting.ControllerCount	!= Setting[Index].ControllerCount
			||	CurrentSetting.LimitationMode	!= Setting[Index].LimitationMode )
			{
				ShowMessageBox(
					 Wnd
					,IDS_RESTART_TITLE
					,IDS_RESTART_MESSAGE
					,MB_OK | MB_ICONINFORMATION );
			}
		}

		//	݂̃Rg[[̐ݒXV
		CopyMemory( &CurrentSetting, &Setting[Index], sizeof( SETTING ) );
		//	݂̃Rg[[̐ݒ̏ԂXV
		CurrentSettingIndex	= Index;

		//	ύXς݃tOXV
		ModifiedFlag	= FALSE;
	}
}

//----------------------------------------------------------------------------------------------
//	ShowMessageBox
//----------------------------------------------------------------------------------------------
LONG CSetting::ShowMessageBox(
	 HWND	Wnd
	,ULONG	TitleID
	,ULONG	MessageID
	,ULONG	Type )
{
	//	bZ[Wǂݍ
	WCHAR	Title[MAX_PATH];
	LoadString( Instance, TitleID, Title, MAX_PATH );
	WCHAR	Message[MAX_PATH];
	LoadString( Instance, MessageID, Message, MAX_PATH );

	//	bZ[W {bNX\
	return( MessageBox( Wnd, Message, Title, Type ) );
}

//----------------------------------------------------------------------------------------------
//	GetSetting
//----------------------------------------------------------------------------------------------
VOID CSetting::GetSetting(
	 LONG		Index
	,SETTING *	Setting )
{
	//	Rg[[̐ݒ擾
	WCHAR	KeyName[MAX_PATH];
	swprintf_s( KeyName, SETTING_DATA, Index );
	GetRegistry( Setting, REG_BINARY, sizeof( SETTING ), KeyName );
}

//----------------------------------------------------------------------------------------------
//	SetSetting
//----------------------------------------------------------------------------------------------
VOID CSetting::SetSetting(
	 LONG		Index
	,SETTING *	Setting )
{
	//	Rg[[̐ݒݒ肷
	WCHAR	KeyName[MAX_PATH];
	swprintf_s( KeyName, SETTING_DATA, Index );
	SetRegistry( Setting, REG_BINARY, sizeof( SETTING ), KeyName );
}

//----------------------------------------------------------------------------------------------
//	DelSetting
//----------------------------------------------------------------------------------------------
VOID CSetting::DelSetting( LONG Index )
{
	//	Rg[[̐ݒ폜
	WCHAR	KeyName[MAX_PATH];
	swprintf_s( KeyName, SETTING_DATA, Index );
	DelRegistry( KeyName );
}

//----------------------------------------------------------------------------------------------
//	GetSettingName
//----------------------------------------------------------------------------------------------
VOID CSetting::GetSettingName(
	 LONG		Index
	,WCHAR *	SettingName
	,LONG		Size )
{
	//	Rg[[̐ݒ擾
	WCHAR	KeyName[MAX_PATH];
	swprintf_s( KeyName, SETTING_NAME, Index );
	GetRegistry( SettingName, REG_SZ, Size, KeyName );
}

//----------------------------------------------------------------------------------------------
//	SetSettingName
//----------------------------------------------------------------------------------------------
VOID CSetting::SetSettingName(
	 LONG		Index
	,WCHAR *	SettingName )
{
	//	Rg[[̐ݒݒ肷
	WCHAR	KeyName[MAX_PATH];
	swprintf_s( KeyName, SETTING_NAME, Index );
	SetRegistry( SettingName, REG_SZ, sizeof( WCHAR ) * wcslen( SettingName ) + 1, KeyName );
}

//----------------------------------------------------------------------------------------------
//	DelSettingName
//----------------------------------------------------------------------------------------------
VOID CSetting::DelSettingName( LONG Index )
{
	//	Rg[[̐ݒ폜
	WCHAR	KeyName[MAX_PATH];
	swprintf_s( KeyName, SETTING_NAME, Index );
	DelRegistry( KeyName );
}

//----------------------------------------------------------------------------------------------
//	GetRegistry
//----------------------------------------------------------------------------------------------
VOID CSetting::GetRegistry(
	 VOID *		Value
	,ULONG		ValueType
	,ULONG		ValueSize
	,WCHAR *	ValueName )
{
	//	ϐ錾
	HKEY	Key;
	DWORD	Disposition;
	LONG	Result;

	//	WXgJ
	Result	= RegCreateKeyEx(
				 HKEY_LOCAL_MACHINE
				,REGISTRY_KEY
				,0
				,NULL
				,REG_OPTION_NON_VOLATILE
				,KEY_ALL_ACCESS
				,NULL
				,&Key
				,&Disposition  );
	if( Result == ERROR_SUCCESS )
	{
		//	WXgǂݍ
		RegQueryValueEx( Key, ValueName, NULL, &ValueType, (LPBYTE)Value, &ValueSize );
		//	WXg
		RegCloseKey( Key );
	}
}

//----------------------------------------------------------------------------------------------
//	SetRegistry
//----------------------------------------------------------------------------------------------
VOID CSetting::SetRegistry(
	 VOID *		Value
	,ULONG		ValueType
	,ULONG		ValueSize
	,WCHAR *	ValueName )
{
	//	ϐ錾
	HKEY	Key;
	DWORD	Disposition;
	LONG	Result;

	//	WXgJ
	Result	= RegCreateKeyEx(
				 HKEY_LOCAL_MACHINE
				,REGISTRY_KEY
				,0
				,NULL
				,REG_OPTION_NON_VOLATILE
				,KEY_ALL_ACCESS
				,NULL
				,&Key
				,&Disposition  );
	if( Result == ERROR_SUCCESS )
	{
		//	WXgɏ
		RegSetValueEx( Key, ValueName, 0, ValueType, (LPBYTE)Value, ValueSize );
		//	WXg
		RegCloseKey( Key );
	}
}

//----------------------------------------------------------------------------------------------
//	DelRegistry
//----------------------------------------------------------------------------------------------
VOID CSetting::DelRegistry( WCHAR * ValueName )
{
	//	ϐ錾
	HKEY	Key;
	DWORD	Disposition;
	LONG	Result;

	//	WXgJ
	Result	= RegCreateKeyEx(
				 HKEY_LOCAL_MACHINE
				,REGISTRY_KEY
				,0
				,NULL
				,REG_OPTION_NON_VOLATILE
				,KEY_ALL_ACCESS
				,NULL
				,&Key
				,&Disposition  );
	if( Result == ERROR_SUCCESS )
	{
		//	WXg폜
		RegDeleteValue( Key, ValueName );
		//	WXg
		RegCloseKey( Key );
	}
}

//----------------------------------------------------------------------------------------------
//	GetDefaultSetting
//----------------------------------------------------------------------------------------------
VOID CSetting::GetDefaultSetting( SETTING * Setting )
{
	//	ϐ錾
	UCHAR	Index;
	UCHAR	WayIndex;

	//	W̐ݒ쐬
	ZeroMemory( Setting, sizeof( SETTING ) );

	//	XeBbN
	Setting->StickUsage[INDEX_LEFT_STICK]	= USAGE_X_AXIS_Y_AXIS;
	Setting->StickUsage[INDEX_RIGHT_STICK]	= USAGE_X_ROTATION_Y_ROTATION;
	for( Index = INDEX_LEFT_STICK; Index <= INDEX_RIGHT_STICK; Index ++ )
	{
		Setting->StickReverseX[Index]			= FALSE;
		Setting->StickReverseY[Index]			= FALSE;
		Setting->StickAngle[Index]				= 0;
		Setting->StickDeadZoneType[Index]		= DEAD_ZONE_TYPE_SQUARE;
		Setting->StickTransformType[Index]		= TRANSFORM_TYPE_NONE;
		Setting->StickMinThreshold[Index]		= 15;
		Setting->StickMaxThreshold[Index]		= 95;
		Setting->StickHatSwitchThreshold[Index]	= 50;
		for( WayIndex = INDEX_WAY_UP; WayIndex <= INDEX_WAY_RIGHT; WayIndex ++ )
		{
			Setting->StickWayUsage[Index][WayIndex]				= USAGE_BUTTON_13 + WayIndex;
			Setting->StickWayRapidFire[Index][WayIndex]			= FALSE;
			Setting->StickWayRapidFireSpeed[Index][WayIndex]	= 80;
		}
	}

	//	pbh
	Setting->DirectionalPadUsage			= USAGE_HAT_SWITCH1;
	Setting->DirectionalPadReverseX			= FALSE;
	Setting->DirectionalPadReverseY			= FALSE;
	Setting->DirectionalPadAngle			= 0;
	Setting->DirectionalPadTransformType	= TRANSFORM_TYPE_NONE;
	for( WayIndex = INDEX_WAY_UP; WayIndex <= INDEX_WAY_RIGHT; WayIndex ++ )
	{
		Setting->DirectionalPadWayUsage[WayIndex]			= USAGE_BUTTON_13 + WayIndex;
		Setting->DirectionalPadWayRapidFire[WayIndex]		= FALSE;
		Setting->DirectionalPadWayRapidFireSpeed[WayIndex]	= 80;
	}

	//	gK[
	for( Index = INDEX_LEFT_TRIGGER; Index <= INDEX_RIGHT_TRIGGER; Index ++ )
	{
		Setting->TriggerUsage[Index]			= USAGE_BUTTON_11 + Index;
		Setting->TriggerRapidFire[Index]		= FALSE;
		Setting->TriggerRapidFireSpeed[Index]	= 80;
		Setting->TriggerMinThreshold[Index]		= 15;
		Setting->TriggerMaxThreshold[Index]		= 95;
		Setting->TriggerButtonThreshold[Index]	= 85;
	}

	//	{^
	for( Index = INDEX_A_BUTTON; Index <= INDEX_RIGHT_STICK_BUTTON; Index ++ )
	{
		Setting->ButtonUsage[Index]				= USAGE_BUTTON_1 + Index;
		Setting->ButtonRapidFire[Index]			= FALSE;
		Setting->ButtonRapidFireSpeed[Index]	= 80;
	}

	//	Xbox KCh {^
	Setting->ButtonUsage[INDEX_XBOX_GUIDE_BUTTON]			= USAGE_BUTTON_13;
	Setting->ButtonRapidFire[INDEX_XBOX_GUIDE_BUTTON]		= FALSE;
	Setting->ButtonRapidFireSpeed[INDEX_XBOX_GUIDE_BUTTON]	= 80;

	//	O Cg
	Setting->RingLightPattern	= 16;

	//	U
	Setting->Actuator								= TRUE;
	Setting->ActuatorLevel[INDEX_LEFT_ACTUATOR]		= 80;
	Setting->ActuatorLevel[INDEX_RIGHT_ACTUATOR]	= 80;
	Setting->ActuatorMinThreshold					= 20;
	Setting->ActuatorMaxThreshold					= 100;

	//	ڍאݒ
	for( Index = Z_AXIS; Index <= SLIDER2; Index ++ )
	{
		Setting->SlideSliderValue[Index]			= FALSE;
		Setting->SlideSliderCenterValue[Index]		= FALSE;
		Setting->ReverseSliderValue[Index]			= FALSE;
	}
	Setting->ControllerCount	= 1;
	Setting->LimitationMode		= LIMITATION_NONE;
}
