
//	Property Sheet for Microsoft Xbox 360 Wireless Controller

#include	"stick_page.h"
#include	"resource.h"

//----------------------------------------------------------------------------------------------
//	CStickPage
//----------------------------------------------------------------------------------------------
CStickPage::CStickPage( CSetting * Setting )
{
	//	ݒ
	this->Setting		= Setting;

	//	݂̃Rg[[̐ݒ
	CurrentSetting		= &Setting->CurrentSetting;

	//	gbN o[̑I
	TrackBarSelecting	= FALSE;
}

//----------------------------------------------------------------------------------------------
//	wmInitDialog
//----------------------------------------------------------------------------------------------
VOID CStickPage::wmInitDialog( HWND Wnd )
{
	//	EBhE nh
	this->Wnd	= Wnd;

	//	XeBbÑt@NV
	WORD	StickFunction[]	= {	 IDS_NONE
								,IDS_X_AXIS_Y_AXIS
								,IDS_X_AXIS_NONE
								,IDS_NONE_X_AXIS
								,IDS_Y_AXIS_X_AXIS
								,IDS_Y_AXIS_NONE
								,IDS_NONE_Y_AXIS
								,IDS_X_ROTATION_Y_ROTATION
								,IDS_X_ROTATION_NONE
								,IDS_NONE_X_ROTATION
								,IDS_Y_ROTATION_X_ROTATION
								,IDS_Y_ROTATION_NONE
								,IDS_NONE_Y_ROTATION
								,IDS_Z_AXIS_ROTATION
								,IDS_Z_AXIS_SLIDER1
								,IDS_Z_AXIS_SLIDER2
								,IDS_Z_AXIS_NONE
								,IDS_NONE_Z_AXIS
								,IDS_Z_ROTATION_AXIS
								,IDS_Z_ROTATION_SLIDER1
								,IDS_Z_ROTATION_SLIDER2
								,IDS_Z_ROTATION_NONE
								,IDS_NONE_Z_ROTATION
								,IDS_SLIDER1_Z_AXIS
								,IDS_SLIDER1_Z_ROTATION
								,IDS_SLIDER1_SLIDER2
								,IDS_SLIDER1_NONE
								,IDS_NONE_SLIDER1
								,IDS_SLIDER2_Z_AXIS
								,IDS_SLIDER2_Z_ROTATION
								,IDS_SLIDER2_SLIDER1
								,IDS_SLIDER2_NONE
								,IDS_NONE_SLIDER2
								,IDS_HAT_SWITCH1
								,IDS_HAT_SWITCH2
								,IDS_HAT_SWITCH3
								,IDS_HAT_SWITCH4 };
	WORD	StickFunctionCount	= sizeof( StickFunction ) / sizeof( WORD ) ;

	//	uXeBbN̋@\ijv
	InitComboBox( IDC_LEFT_STICK_USAGE, StickFunction, StickFunctionCount );
	//	uXeBbN̋@\iEjv
	InitComboBox( IDC_RIGHT_STICK_USAGE, StickFunction, StickFunctionCount );
	//	uĹ͈v
	InitTrackBar( IDC_STICK_THRESHOLD, 0, 100, 10, 10 );
	//	uXeBbN̓臒lv
	InitTrackBar( IDC_STICK_HAT_SWITCH_THRESHOLD, 0, 100, 10, 10 );
}

//----------------------------------------------------------------------------------------------
//	wmCommand
//----------------------------------------------------------------------------------------------
VOID CStickPage::wmCommand(
	 HWND	Control
	,WORD	ControlID
	,WORD	NotifyMessage )
{
	//	Rg[ɂďU蕪
	switch( ControlID )
	{
		case IDC_LEFT_STICK_USAGE:

			//	ʒmbZ[WɂďU蕪
			switch( NotifyMessage )
			{
				case CBN_SELCHANGE:
					//	݂̐ݒɔf
					CurrentSetting->StickUsage[INDEX_LEFT_STICK]
						= GetComboBoxIndex( ControlID );
					//	ݒ̕ύXʒm
					SettingChanged();
					break;
			}
			break;

		case IDC_RIGHT_STICK_USAGE:

			//	ʒmbZ[WɂďU蕪
			switch( NotifyMessage )
			{
				case CBN_SELCHANGE:
					//	݂̐ݒɔf
					CurrentSetting->StickUsage[INDEX_RIGHT_STICK]
						= GetComboBoxIndex( ControlID );
					//	ݒ̕ύXʒm
					SettingChanged();
					break;
			}
			break;

		case IDC_LEFT_STICK_REVERSE_Y:

			//	ʒmbZ[WɂďU蕪
			switch( NotifyMessage )
			{
				case BN_CLICKED:
					//	݂̐ݒɔf
					CurrentSetting->StickReverseY[INDEX_LEFT_STICK]
						= GetCheckBoxState( ControlID );
					//	ݒ̕ύXʒm
					SettingChanged();
					break;
			}
			break;

		case IDC_RIGHT_STICK_REVERSE_Y:

			//	ʒmbZ[WɂďU蕪
			switch( NotifyMessage )
			{
				case BN_CLICKED:
					//	݂̐ݒɔf
					CurrentSetting->StickReverseY[INDEX_RIGHT_STICK]
						= GetCheckBoxState( ControlID );
					//	ݒ̕ύXʒm
					SettingChanged();
					break;
			}
			break;
	}
}

//----------------------------------------------------------------------------------------------
//	wmHScroll
//----------------------------------------------------------------------------------------------
VOID CStickPage::wmHScroll(
	 HWND	Control
	,WORD	Request )
{
	//	uĹ͈ṽbZ[W
	if( Control == GetDlgItem( Wnd, IDC_STICK_THRESHOLD ) )
	{
		//	݂̑IԂޔ
		BOOL	PrevSelecting	= TrackBarSelecting;

		//	gbN o[͈̔͑Is
		SelectTrackBar( Control, Request, &TrackBarSelecting );
		if( PrevSelecting != TrackBarSelecting )
		{
			//	݂̐ݒɔf
			GetTrackBarRange(
				 IDC_STICK_THRESHOLD
				,&CurrentSetting->StickMinThreshold[INDEX_LEFT_STICK]
				,&CurrentSetting->StickMaxThreshold[INDEX_LEFT_STICK] );
			CurrentSetting->StickMinThreshold[INDEX_RIGHT_STICK]
				= CurrentSetting->StickMinThreshold[INDEX_LEFT_STICK];
			CurrentSetting->StickMaxThreshold[INDEX_RIGHT_STICK]
				= CurrentSetting->StickMaxThreshold[INDEX_LEFT_STICK];
			//	ݒ̕ύXʒm
			SettingChanged();
		}
	}

	//	uXeBbN̓臒lṽbZ[W
	if( Control == GetDlgItem( Wnd, IDC_STICK_HAT_SWITCH_THRESHOLD ) )
	{
		//	݂̐ݒɔf
		CurrentSetting->StickHatSwitchThreshold[INDEX_LEFT_STICK]
			= GetTrackBarPos( IDC_STICK_HAT_SWITCH_THRESHOLD );
		CurrentSetting->StickHatSwitchThreshold[INDEX_RIGHT_STICK]
			= CurrentSetting->StickHatSwitchThreshold[INDEX_LEFT_STICK];
		//	ݒ̕ύXʒm
		SettingChanged();
	}
}

//----------------------------------------------------------------------------------------------
//	ApplySetting
//----------------------------------------------------------------------------------------------
VOID CStickPage::ApplySetting()
{
	//	uXeBbN̋@\ijv
	SetComboBoxIndex( IDC_LEFT_STICK_USAGE, CurrentSetting->StickUsage[INDEX_LEFT_STICK] );
	//	u㉺𔽓]ijv
	SetCheckBoxState(
		 IDC_LEFT_STICK_REVERSE_Y
		,CurrentSetting->StickReverseY[INDEX_LEFT_STICK] );
	//	uXeBbN̋@\ijvuȂv̏ꍇ́Au㉺𔽓]ijv𖳌ɂ
	if( CurrentSetting->StickUsage[INDEX_LEFT_STICK] == USAGE_NONE )
	{
		EnableControl( IDC_LEFT_STICK_REVERSE_Y, FALSE );
	} else {
		EnableControl( IDC_LEFT_STICK_REVERSE_Y, TRUE );
	}

	//	uXeBbN̋@\iEjv
	SetComboBoxIndex( IDC_RIGHT_STICK_USAGE, CurrentSetting->StickUsage[INDEX_RIGHT_STICK] );
	//	u㉺𔽓]iEjv
	SetCheckBoxState(
		 IDC_RIGHT_STICK_REVERSE_Y
		,CurrentSetting->StickReverseY[INDEX_RIGHT_STICK] );
	//	uXeBbN̋@\iEjvuȂv̏ꍇ́Au㉺𔽓]iEjv𖳌ɂ
	if( CurrentSetting->StickUsage[INDEX_RIGHT_STICK] == USAGE_NONE )
	{
		EnableControl( IDC_RIGHT_STICK_REVERSE_Y, FALSE );
	} else {
		EnableControl( IDC_RIGHT_STICK_REVERSE_Y, TRUE );
	}

	//	uĹ͈v
	SetTrackBarRange(
		 IDC_STICK_THRESHOLD
		,CurrentSetting->StickMinThreshold[INDEX_LEFT_STICK]
		,CurrentSetting->StickMaxThreshold[INDEX_LEFT_STICK] );
	SetTrackBarPos( IDC_STICK_THRESHOLD, CurrentSetting->StickMinThreshold[INDEX_LEFT_STICK] );
	//	uXeBbN̓臒lv
	SetTrackBarPos(
		 IDC_STICK_HAT_SWITCH_THRESHOLD
		,CurrentSetting->StickHatSwitchThreshold[INDEX_LEFT_STICK] );
}
