
//	Property Sheet for Microsoft Xbox 360 Wireless Controller

#include	"trigger_page.h"
#include	"resource.h"

//----------------------------------------------------------------------------------------------
//	CTriggerPage
//----------------------------------------------------------------------------------------------
CTriggerPage::CTriggerPage( CSetting * Setting )
{
	//	ݒ
	this->Setting		= Setting;

	//	݂̃Rg[[̐ݒ
	CurrentSetting		= &Setting->CurrentSetting;

	//	gbN o[̑I
	TrackBarSelecting	= FALSE;
}

//----------------------------------------------------------------------------------------------
//	wmInitDialog
//----------------------------------------------------------------------------------------------
VOID CTriggerPage::wmInitDialog( HWND Wnd )
{
	//	EBhE nh
	this->Wnd	= Wnd;

	//	gK[̃t@NV
	WORD	TriggerFunction[]	= {	 IDS_NONE
									,IDS_X_AXIS_PLUS
									,IDS_X_AXIS_MINUS
									,IDS_Y_AXIS_PLUS
									,IDS_Y_AXIS_MINUS
									,IDS_X_ROTATION_PLUS
									,IDS_X_ROTATION_MINUS
									,IDS_Y_ROTATION_PLUS
									,IDS_Y_ROTATION_MINUS
									,IDS_Z_AXIS_PLUS
									,IDS_Z_AXIS_MINUS
									,IDS_Z_ROTATION_PLUS
									,IDS_Z_ROTATION_MINUS
									,IDS_SLIDER1_PLUS
									,IDS_SLIDER1_MINUS
									,IDS_SLIDER2_PLUS
									,IDS_SLIDER2_MINUS
									,IDS_BUTTON1
									,IDS_BUTTON2
									,IDS_BUTTON3
									,IDS_BUTTON4
									,IDS_BUTTON5
									,IDS_BUTTON6
									,IDS_BUTTON7
									,IDS_BUTTON8
									,IDS_BUTTON9
									,IDS_BUTTON10
									,IDS_BUTTON11
									,IDS_BUTTON12
									,IDS_BUTTON13
									,IDS_BUTTON14
									,IDS_BUTTON15
									,IDS_BUTTON16
									,IDS_BUTTON17
									,IDS_BUTTON18
									,IDS_BUTTON19
									,IDS_BUTTON20
									,IDS_BUTTON21
									,IDS_BUTTON22
									,IDS_BUTTON23
									,IDS_BUTTON24
									,IDS_BUTTON25
									,IDS_BUTTON26
									,IDS_BUTTON27
									,IDS_BUTTON28
									,IDS_BUTTON29
									,IDS_BUTTON30
									,IDS_BUTTON31
									,IDS_BUTTON32 };
	WORD	TriggerFunctionCount	= sizeof( TriggerFunction ) / sizeof( WORD ) ;

	//	ugK[̋@\ijv
	InitComboBox( IDC_LEFT_TRIGGER_USAGE, TriggerFunction, TriggerFunctionCount );
	//	ugK[̋@\iEjv
	InitComboBox( IDC_RIGHT_TRIGGER_USAGE, TriggerFunction, TriggerFunctionCount );
	//	uڍאݒv
	InitTrackBar( IDC_TRIGGER_THRESHOLD, 0, 100, 10, 10 );
	//	ugK[̓臒lv
	InitTrackBar( IDC_TRIGGER_BUTTON_THRESHOLD, 0, 100, 10, 10 );
}

//----------------------------------------------------------------------------------------------
//	wmCommand
//----------------------------------------------------------------------------------------------
VOID CTriggerPage::wmCommand(
	 HWND	Control
	,WORD	ControlID
	,WORD	NotifyMessage )
{
	//	Rg[ɂďU蕪
	switch( ControlID )
	{
		case IDC_LEFT_TRIGGER_USAGE:

			//	ʒmbZ[WɂďU蕪
			switch( NotifyMessage )
			{
				case CBN_SELCHANGE:
					//	݂̐ݒɔf
					CurrentSetting->TriggerUsage[INDEX_LEFT_TRIGGER]
						= GetWayUsageByControlIndex( ControlID );
					//	ݒ̕ύXʒm
					SettingChanged();
					break;
			}
			break;

		case IDC_RIGHT_TRIGGER_USAGE:

			//	ʒmbZ[WɂďU蕪
			switch( NotifyMessage )
			{
				case CBN_SELCHANGE:
					//	݂̐ݒɔf
					CurrentSetting->TriggerUsage[INDEX_RIGHT_TRIGGER]
						= GetWayUsageByControlIndex( ControlID );
					//	ݒ̕ύXʒm
					SettingChanged();
					break;
			}
			break;

		case IDC_LEFT_TRIGGER_RAPID_FIRE:

			//	ʒmbZ[WɂďU蕪
			switch( NotifyMessage )
			{
				case BN_CLICKED:
					//	݂̐ݒɔf
					CurrentSetting->TriggerRapidFire[INDEX_LEFT_TRIGGER]
						= GetCheckBoxState( ControlID );
					//	ݒ̕ύXʒm
					SettingChanged();
					break;
			}
			break;

		case IDC_RIGHT_TRIGGER_RAPID_FIRE:

			//	ʒmbZ[WɂďU蕪
			switch( NotifyMessage )
			{
				case BN_CLICKED:
					//	݂̐ݒɔf
					CurrentSetting->TriggerRapidFire[INDEX_RIGHT_TRIGGER]
						= GetCheckBoxState( ControlID );
					//	ݒ̕ύXʒm
					SettingChanged();
					break;
			}
			break;

	}
}

//----------------------------------------------------------------------------------------------
//	wmHScroll
//----------------------------------------------------------------------------------------------
VOID CTriggerPage::wmHScroll(
	 HWND	Control
	,WORD	Request )
{
	//	uĹ͈ṽbZ[W
	if( Control == GetDlgItem( Wnd, IDC_TRIGGER_THRESHOLD ) )
	{
		//	݂̑IԂޔ
		BOOL	PrevSelecting	= TrackBarSelecting;

		//	gbN o[͈̔͑Is
		SelectTrackBar( Control, Request, &TrackBarSelecting );
		if( PrevSelecting != TrackBarSelecting )
		{
			//	݂̐ݒɔf
			GetTrackBarRange(
				 IDC_TRIGGER_THRESHOLD
				,&CurrentSetting->TriggerMinThreshold[INDEX_LEFT_TRIGGER]
				,&CurrentSetting->TriggerMaxThreshold[INDEX_LEFT_TRIGGER] );
			CurrentSetting->TriggerMinThreshold[INDEX_RIGHT_TRIGGER]
				= CurrentSetting->TriggerMinThreshold[INDEX_LEFT_TRIGGER];
			CurrentSetting->TriggerMaxThreshold[INDEX_RIGHT_TRIGGER]
				= CurrentSetting->TriggerMaxThreshold[INDEX_LEFT_TRIGGER];
			//	ݒ̕ύXʒm
			SettingChanged();
		}
	}

	//	ugK[̓臒lṽbZ[W
	if( Control == GetDlgItem( Wnd, IDC_TRIGGER_BUTTON_THRESHOLD ) )
	{
		//	݂̐ݒɔf
		CurrentSetting->TriggerButtonThreshold[INDEX_LEFT_TRIGGER]
			= GetTrackBarPos( IDC_TRIGGER_BUTTON_THRESHOLD );
		CurrentSetting->TriggerButtonThreshold[INDEX_RIGHT_TRIGGER]
			= CurrentSetting->TriggerButtonThreshold[INDEX_LEFT_TRIGGER];
		//	ݒ̕ύXʒm
		SettingChanged();
	}
}

//----------------------------------------------------------------------------------------------
//	ApplySetting
//----------------------------------------------------------------------------------------------
VOID CTriggerPage::ApplySetting()
{
	//	ugK[̋@\ijv
	SetComboBoxIndex(
		 IDC_LEFT_TRIGGER_USAGE
		,GetControlIndexByWayUsage( CurrentSetting->TriggerUsage[INDEX_LEFT_TRIGGER] ) );
	//	ugK[̘A˂sijv
	SetCheckBoxState(
		 IDC_LEFT_TRIGGER_RAPID_FIRE
		,CurrentSetting->TriggerRapidFire[INDEX_LEFT_TRIGGER] );
	//	ugK[̋@\ijvuȂv̏ꍇ́AugK[̘A˂sijv𖳌ɂ
	if( CurrentSetting->TriggerUsage[INDEX_LEFT_TRIGGER] == USAGE_NONE )
	{
		EnableControl( IDC_LEFT_TRIGGER_RAPID_FIRE, FALSE );
	} else {
		EnableControl( IDC_LEFT_TRIGGER_RAPID_FIRE, TRUE );
	}

	//	ugK[̋@\iEjv
	SetComboBoxIndex(
		 IDC_RIGHT_TRIGGER_USAGE
		,GetControlIndexByWayUsage( CurrentSetting->TriggerUsage[INDEX_RIGHT_TRIGGER] ) );
	//	ugK[̘A˂siEjv
	SetCheckBoxState(
		 IDC_RIGHT_TRIGGER_RAPID_FIRE
		,CurrentSetting->TriggerRapidFire[INDEX_RIGHT_TRIGGER] );
	//	ugK[̋@\iEjvuȂv̏ꍇ́AugK[̘A˂siEjv𖳌ɂ
	if( CurrentSetting->TriggerUsage[INDEX_RIGHT_TRIGGER] == USAGE_NONE )
	{
		EnableControl( IDC_RIGHT_TRIGGER_RAPID_FIRE, FALSE );
	} else {
		EnableControl( IDC_RIGHT_TRIGGER_RAPID_FIRE, TRUE );
	}

	//	uĹ͈v
	SetTrackBarRange(
		 IDC_TRIGGER_THRESHOLD
		,CurrentSetting->TriggerMinThreshold[INDEX_LEFT_TRIGGER]
		,CurrentSetting->TriggerMaxThreshold[INDEX_LEFT_TRIGGER] );
	SetTrackBarPos(
		 IDC_TRIGGER_THRESHOLD
		,CurrentSetting->TriggerMinThreshold[INDEX_LEFT_TRIGGER] );
	//	ugK[̓臒lv
	SetTrackBarPos(
		 IDC_TRIGGER_BUTTON_THRESHOLD
		,CurrentSetting->TriggerButtonThreshold[INDEX_LEFT_TRIGGER] );
}
