
//	Status Area Icon for Microsoft Xbox 360 Wireless Controller

#include	"status_area_icon.h"
#include	"resource.h"

//----------------------------------------------------------------------------------------------
//	CStatusAreaIcon
//----------------------------------------------------------------------------------------------
CStatusAreaIcon::CStatusAreaIcon(
	 HINSTANCE	Instance
	,HWND		Wnd )
{
	//	CX^X
	this->Instance	= Instance;
	//	EBhE nh
	this->Wnd		= Wnd;

	//	vZX ID
	ProcessID		= NULL;

	//	eCX^X쐬
	Setting			= new CSetting( Instance, Wnd );
	PropertySheet	= new CPropertySheet( Instance, Wnd );
	Device			= new CDevice();

	//	foCX݂΃Xe[^X GAɃACRǉ
	if( Device->IsConnected() == TRUE )
	{
		ShowIcon();
	}

	//	ݒ̎؊p^C}[Jn
	if( Setting->AutoSettingChange == TRUE )
	{
		SetTimer( Wnd, AUTO_SETTING_CHANGE_TIMER, 0, NULL );
	}
}

//----------------------------------------------------------------------------------------------
//	~CStatusAreaIcon
//----------------------------------------------------------------------------------------------
CStatusAreaIcon::~CStatusAreaIcon()
{
	//	Xe[^X GAACR폜
	HideIcon();

	//	eCX^XJ
	delete Device;
	delete PropertySheet;
	delete Setting;
}

//----------------------------------------------------------------------------------------------
//	wmNotify
//----------------------------------------------------------------------------------------------
VOID CStatusAreaIcon::wmNotify(
	 WPARAM	wParam
	,LPARAM	lParam )
{
	switch( wParam )
	{
		case STATUS_AREA_ICON_ID:
			switch( lParam )
			{
				case WM_LBUTTONDOWN:
					//	^C}[Ń|bvAbv j[ij\
					SetTimer( Wnd, LEFT_CLICK_TIMER, GetDoubleClickTime(), NULL );
					break;

				case WM_LBUTTONDBLCLK:
					//	NbNp^C}[~
					KillTimer( Wnd, LEFT_CLICK_TIMER );
					//	vpeB V[gJ
					if( PropertySheet->IsOpened() == FALSE )
					{
						PropertySheet->Open();
					}
					break;

				case WM_RBUTTONUP:
					//	|bvAbv j[iEj\
					ShowRightPopupMenu();
					break;
			}
			break;

		case UPDATE_SETTING:
			//	WXgݒǂݍ
			Setting->LoadRegistry();
			break;
	}
}

//----------------------------------------------------------------------------------------------
//	wmCommand
//----------------------------------------------------------------------------------------------
VOID CStatusAreaIcon::wmCommand( WORD CommandId )
{
	switch( CommandId )
	{
		case IDM_PROPERTY:
			//	vpeB(&P)
			PropertySheet->Open();
			break;

		case IDM_AUTO_SETTING_CHANGE:
			//	ݒ̎؊(A)
			if( Setting->AutoSettingChange == TRUE )
			{
				//	ݒ̎؊~
				KillTimer( Wnd, AUTO_SETTING_CHANGE_TIMER );
				Setting->AutoSettingChange	= FALSE;
			} else {
				//	ݒ̎؊Jn
				SetTimer( Wnd, AUTO_SETTING_CHANGE_TIMER, 0, NULL );
				Setting->AutoSettingChange	= TRUE;
			}
			//	WXgɐݒ
			Setting->SaveRegistry();
			break;

		case IDM_EXIT:
			//	I(X)
			if( PropertySheet->IsOpened() == FALSE )
			{
				PostMessage( Wnd, WM_CLOSE, 0, 0 );
			}
			break;

		default:
			//	Rg[[̐ݒύX
			LONG	SettingIndex	= CommandId - IDM_SETTING;
			if(	PropertySheet->IsOpened() == FALSE
			&&	0 <= SettingIndex && SettingIndex < Setting->SettingCount
			&&	SettingIndex != Setting->CurrentSettingIndex )
			{
				//	Rg[[̐ݒύX
				Setting->Change( SettingIndex, FALSE );
				Setting->SaveRegistry();
				Device->Apply();
			}
			break;
	}
}

//----------------------------------------------------------------------------------------------
//	wmTimer
//----------------------------------------------------------------------------------------------
VOID CStatusAreaIcon::wmTimer( WPARAM TimerId )
{
	switch( TimerId )
	{
		case LEFT_CLICK_TIMER:
			//	NbNp^C}[~
			KillTimer( Wnd, TimerId );
			//	|bvAbv j[ij\
			ShowLeftPopupMenu();
			break;

		case AUTO_SETTING_CHANGE_TIMER:
			//	ݒ̎؊p^C}[~
			KillTimer( Wnd, TimerId );

			//	tHA OEh̃AvP[ṼvZX ID 擾
			DWORD	CurrentProcessID;
			GetWindowThreadProcessId( GetForegroundWindow(), &CurrentProcessID );
			if( ProcessID != CurrentProcessID )
			{
				//	ݒ̎؊s
				if(	PropertySheet->IsOpened() == FALSE
				&&	Setting->ModifiedFlag == FALSE )
				{
					AutomaticChange( CurrentProcessID );
					//	vZX ID ޔ
					ProcessID	= CurrentProcessID;
				}
			}

			//	ݒ̎؊p^C}[Jn
			SetTimer( Wnd, AUTO_SETTING_CHANGE_TIMER, CHECK_INTERVAL, NULL );
			break;
	}
}

//----------------------------------------------------------------------------------------------
//	wmDeviceChange
//----------------------------------------------------------------------------------------------
VOID CStatusAreaIcon::wmDeviceChange()
{
	//	foCX̗LɂăACR̕\A\؊
	if( Device->IsConnected() == TRUE )
	{
		//	Xe[^X GAɃACRǉ
		ShowIcon();
	} else {
		//	Xe[^X GAACR폜
		HideIcon();
	}
}

//----------------------------------------------------------------------------------------------
//	wmTaskbarCtreated
//----------------------------------------------------------------------------------------------
VOID CStatusAreaIcon::wmTaskbarCtreated()
{
	//	foCXL΃Xe[^X GAɃACRǉ
	if( Device->IsConnected() == TRUE )
	{
		ShowIcon();
	}
}

//----------------------------------------------------------------------------------------------
//	ShowIcon
//----------------------------------------------------------------------------------------------
VOID CStatusAreaIcon::ShowIcon()
{
	//	Xe[^X GAɃACRǉ
	NOTIFYICONDATA	IconData;
	ZeroMemory( &IconData, sizeof( NOTIFYICONDATA ) );
	IconData.cbSize				= sizeof( NOTIFYICONDATA );
	IconData.hWnd				= Wnd;
	IconData.uID				= STATUS_AREA_ICON_ID;
	IconData.uFlags				= NIF_ICON | NIF_MESSAGE | NIF_TIP;
	IconData.uCallbackMessage	= WM_STATUS_AREA_ICON_NOTIFY;
	IconData.hIcon				= (HICON)LoadImage(
									 Instance
									,MAKEINTRESOURCE( IDI_ICON )
									,IMAGE_ICON
									,0
									,0
									,LR_DEFAULTSIZE );
	LoadString(
		 Instance
		,IDS_ICON_TIP
		,IconData.szTip
		,sizeof( IconData.szTip ) / sizeof( TCHAR ) );
	Shell_NotifyIcon( NIM_ADD, &IconData );
	//	ACR폜
	if( IconData.hIcon != NULL )
	{
		DestroyIcon( IconData.hIcon );
	}
	SetForegroundWindow( Wnd );
}

//----------------------------------------------------------------------------------------------
//	HideIcon
//----------------------------------------------------------------------------------------------
VOID CStatusAreaIcon::HideIcon()
{
	//	Xe[^X GAACR폜
	NOTIFYICONDATA	IconData;
	ZeroMemory( &IconData, sizeof( NOTIFYICONDATA ) );
	IconData.cbSize	= sizeof( NOTIFYICONDATA );
	IconData.hWnd	= Wnd;
	IconData.uID	= STATUS_AREA_ICON_ID;
	Shell_NotifyIcon( NIM_DELETE, &IconData );
}

//----------------------------------------------------------------------------------------------
//	ShowLeftPopupMenu
//----------------------------------------------------------------------------------------------
VOID CStatusAreaIcon::ShowLeftPopupMenu()
{
	//	vpeB V[g̏Ԃ擾
	BOOL	PropertySheetOpened	= PropertySheet->IsOpened();

	//	|bvAbv j[쐬
	HMENU	PopupMenu	= CreatePopupMenu();

	//	Rg[[̐ݒ\
	for( LONG Index = 0; Index < Setting->SettingCount; Index ++ )
	{
		MENUITEMINFO	ItemInfo;
		ZeroMemory( &ItemInfo, sizeof( ItemInfo ) );
		ItemInfo.cbSize	= sizeof( ItemInfo );
		ItemInfo.fMask	= MIIM_TYPE | MIIM_STATE | MIIM_ID;
		ItemInfo.fType	= MFT_STRING;
		ItemInfo.fState	= MFS_ENABLED;
		if( PropertySheetOpened == TRUE )
		{
			ItemInfo.fState	|= MFS_DISABLED;
		}
		ItemInfo.wID	= IDM_SETTING + Index;
		if( Setting->CurrentSettingIndex == Index )
		{
			ItemInfo.fState		|= MFS_CHECKED;
		}
		WCHAR	SettingName[MAX_PATH * 2];
		wcscpy_s( SettingName, Setting->SettingName[Index] );
		//	ύXς݃tOオĂ΁uiύXς݁jvݒ肷
		if( Setting->ModifiedFlag == TRUE && Setting->CurrentSettingIndex == Index )
		{
			WCHAR	Modified[MAX_PATH];
			LoadString( Instance, IDS_MODIFIED, Modified, MAX_PATH );
			wcscat_s( SettingName, Modified );
		}
		ItemInfo.dwTypeData	= SettingName;
		InsertMenuItem( PopupMenu, Index, TRUE, &ItemInfo );
	}

	//	|bvAbv j[\
	SetForegroundWindow( Wnd );
	POINT	CursorPos;
	GetCursorPos( &CursorPos );
	TrackPopupMenuEx(
		 PopupMenu
		,TPM_LEFTALIGN | TPM_RIGHTBUTTON
		,CursorPos.x
		,CursorPos.y
		,Wnd
		,NULL );
	DestroyMenu( PopupMenu );
	PostMessage( Wnd, WM_NULL, 0, 0 );
}

//----------------------------------------------------------------------------------------------
//	ShowRightPopupMenu
//----------------------------------------------------------------------------------------------
VOID CStatusAreaIcon::ShowRightPopupMenu()
{
	//	vpeB V[g̏Ԃ擾
	BOOL	PropertySheetOpened	= PropertySheet->IsOpened();

	//	|bvAbv j[쐬
	HMENU	Menu		= LoadMenu( Instance, MAKEINTRESOURCE( IDR_MENU ) );
	HMENU	PopupMenu	= GetSubMenu( Menu, 0 );

	//	uvpeBvftHgɂ
	MENUITEMINFO	ItemInfo;
	ZeroMemory( &ItemInfo, sizeof( ItemInfo ) );
	ItemInfo.cbSize	= sizeof( ItemInfo );
	GetMenuItemInfo( PopupMenu, IDM_PROPERTY, FALSE, &ItemInfo );
	ItemInfo.fMask	= MIIM_STATE;
	ItemInfo.fState	= MFS_ENABLED | MFS_DEFAULT;
	if( PropertySheetOpened == TRUE )
	{
		ItemInfo.fState	|= MFS_DISABLED;
	}
	SetMenuItemInfo( PopupMenu, IDM_PROPERTY, FALSE, &ItemInfo );

	//	uݒ̎؊ṽ`FbNݒ肷
	GetMenuItemInfo( PopupMenu, IDM_AUTO_SETTING_CHANGE, FALSE, &ItemInfo );
	ItemInfo.fMask	= MIIM_STATE;
	ItemInfo.fState	= MFS_ENABLED;
	if( Setting->AutoSettingChange == TRUE )
	{
		ItemInfo.fState	|= MFS_CHECKED;
	}
	if( PropertySheetOpened == TRUE )
	{
		ItemInfo.fState	|= MFS_DISABLED;
	}
	SetMenuItemInfo( PopupMenu, IDM_AUTO_SETTING_CHANGE, FALSE, &ItemInfo );

	//	uIv̗LEݒ肷
	GetMenuItemInfo( PopupMenu, IDM_EXIT, FALSE, &ItemInfo );
	ItemInfo.fMask	= MIIM_STATE;
	ItemInfo.fState	= MFS_ENABLED;
	if( PropertySheetOpened == TRUE )
	{
		ItemInfo.fState	|= MFS_DISABLED;
	}
	SetMenuItemInfo( PopupMenu, IDM_EXIT, FALSE, &ItemInfo );

	//	|bvAbv j[\
	SetForegroundWindow( Wnd );
	POINT	CursorPos;
	GetCursorPos( &CursorPos );
	TrackPopupMenuEx(
		 PopupMenu
		,TPM_LEFTALIGN | TPM_RIGHTBUTTON
		,CursorPos.x
		,CursorPos.y
		,Wnd
		,NULL );
	DestroyMenu( Menu );
	PostMessage( Wnd, WM_NULL, 0, 0 );
}

//----------------------------------------------------------------------------------------------
//	AutomaticChange
//----------------------------------------------------------------------------------------------
VOID CStatusAreaIcon::AutomaticChange( DWORD ProcessID )
{
	//	vZX̃XibvVbg쐬
	HANDLE	ProcessSnapshot	= CreateToolhelp32Snapshot( TH32CS_SNAPPROCESS, 0 );

	//	vZX̃Gg擾
	PROCESSENTRY32	ProcessEntry;
	ZeroMemory( &ProcessEntry, sizeof( PROCESSENTRY32 ) );
	ProcessEntry.dwSize = sizeof( PROCESSENTRY32 );
	Process32FirstW( ProcessSnapshot, &ProcessEntry );
	//	SẴvZX
	do
	{
		//	tHAOEh̃AvP[VT
		if( ProcessEntry.th32ProcessID == ProcessID )
		{
			//	W[؂o
			WCHAR	ModuleName[MAX_PATH];
			if( wcschr( ProcessEntry.szExeFile, '\\' ) == NULL )
			{
				wcscpy_s( ModuleName, ProcessEntry.szExeFile );
			} else {
				wcscpy_s( ModuleName, &(wcsrchr( ProcessEntry.szExeFile, '\\' )[1]) );
			}

			//	W[ƈvRg[[̐ݒ
			for( LONG Index = 1; Index < Setting->SettingCount; Index ++ )
			{
				if(	( _wcsicmp( ModuleName, Setting->SettingName[Index] ) == 0 )
				&&	( Setting->CurrentSettingIndex != Index ) )
				{
					//	Rg[[̐ݒύX
					Setting->Change( Index, TRUE );
					Setting->SaveRegistry();
					Device->Apply();
					break;
				}
			}
			break;
		}
	} while( Process32NextW(ProcessSnapshot, &ProcessEntry ) );

	//	XibvVbg
	CloseHandle( ProcessSnapshot );
}
